
/* Initng, a next generation sysvinit replacement.
 * Copyright (C) 2005 Jimmy Wennlund <jimmy.wennlund@gmail.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef INITNG_SYSLOG_H
#define INITNG_SYSLOG_H
#include <sys/types.h>
#include "../../src/initng_active_status.h"
#include "../../src/initng_active_db.h"

extern int syslog_running;

typedef struct 
{
    int prio;
    char *owner;
    char *buffert;
    struct list_head list;
} log_ent;

log_ent log_list;

#define while_log_list_safe(current, safe) list_for_each_entry_prev_safe(current, safe, &log_list.list, list)

int module_init(const char *version);
void module_unload(void);
#endif
