/* Initng, a next generation sysvinit replacement.
 * Copyright (C) 2005 Jimmy Wennlund <jimmy.wennlund@gmail.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef INITNG_PLUGIN
#define INITNG_PLUGIN
#include <stdarg.h>
#include "initng_plugin_type.h"
#include "initng_system_states.h"
#include "initng_list.h"

typedef struct
{
    void (*call_module) (void);
    int fds;
} f_module_h;

typedef struct
{
    void (*call_module) (void);
    time_t seconds;
    time_t next_hit;
} t_module_h;

typedef union
{
    int (*hook) (void *arg_data);
    void *(*phook) (void *arg_data);
    int (*test_status) (active_h *service, e_a_status status);
    void (*swatcher) (h_sys_state state);
    void (*pipewatcher) (active_h * service, int datalen, process_h * process,
                         int forceflush);
    int (*af_launcher) (active_h * service, process_h * process);
    int (*handle_killed) (active_h * service, process_h * process);
    void (*main) (void);
    void (*compensate_time) (int seconds);
    void (*err) (e_mt mt, const char *file, const char *func, int line, const char *format, va_list ap);
    f_module_h *fdh;
    t_module_h *tdh;
} uc;

typedef struct s_callers_s s_call;

struct s_callers_s
{
    char *from_file;
    e_ptype ptype;
    uc c;
    int order;
    struct list_head list;
};

#define while_call_db(current) list_for_each_entry_prev(current, &g.call_db.list, list)
#define while_call_db_safe(current, safe) list_for_each_entry_prev_safe(current, safe, &g.call_db.list, list)

#endif
